/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the HighlightMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HighlightMutable{}

// HighlightMutable struct for HighlightMutable
type HighlightMutable struct {
	Template string `json:"template"`
	Metric HighlightMetric `json:"metric"`
	Frequency Frequency `json:"frequency"`
	OutsideBusinessHours bool `json:"outside_business_hours"`
	Weekdays []int32 `json:"weekdays"`
	StartAt time.Time `json:"start_at"`
	EndAt time.Time `json:"end_at"`
}

// NewHighlightMutable instantiates a new HighlightMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHighlightMutable(template string, metric HighlightMetric, frequency Frequency, outsideBusinessHours bool, weekdays []int32, startAt time.Time, endAt time.Time) *HighlightMutable {
	this := HighlightMutable{}
	this.Template = template
	this.Metric = metric
	this.Frequency = frequency
	this.OutsideBusinessHours = outsideBusinessHours
	this.Weekdays = weekdays
	this.StartAt = startAt
	this.EndAt = endAt
	return &this
}

// NewHighlightMutableWithDefaults instantiates a new HighlightMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHighlightMutableWithDefaults() *HighlightMutable {
	this := HighlightMutable{}
	return &this
}

// GetTemplate returns the Template field value
func (o *HighlightMutable) GetTemplate() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Template
}

// GetTemplateOk returns a tuple with the Template field value
// and a boolean to check if the value has been set.
func (o *HighlightMutable) GetTemplateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Template, true
}

// SetTemplate sets field value
func (o *HighlightMutable) SetTemplate(v string) {
	o.Template = v
}

// GetMetric returns the Metric field value
func (o *HighlightMutable) GetMetric() HighlightMetric {
	if o == nil {
		var ret HighlightMetric
		return ret
	}

	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value
// and a boolean to check if the value has been set.
func (o *HighlightMutable) GetMetricOk() (*HighlightMetric, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Metric, true
}

// SetMetric sets field value
func (o *HighlightMutable) SetMetric(v HighlightMetric) {
	o.Metric = v
}

// GetFrequency returns the Frequency field value
func (o *HighlightMutable) GetFrequency() Frequency {
	if o == nil {
		var ret Frequency
		return ret
	}

	return o.Frequency
}

// GetFrequencyOk returns a tuple with the Frequency field value
// and a boolean to check if the value has been set.
func (o *HighlightMutable) GetFrequencyOk() (*Frequency, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Frequency, true
}

// SetFrequency sets field value
func (o *HighlightMutable) SetFrequency(v Frequency) {
	o.Frequency = v
}

// GetOutsideBusinessHours returns the OutsideBusinessHours field value
func (o *HighlightMutable) GetOutsideBusinessHours() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.OutsideBusinessHours
}

// GetOutsideBusinessHoursOk returns a tuple with the OutsideBusinessHours field value
// and a boolean to check if the value has been set.
func (o *HighlightMutable) GetOutsideBusinessHoursOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OutsideBusinessHours, true
}

// SetOutsideBusinessHours sets field value
func (o *HighlightMutable) SetOutsideBusinessHours(v bool) {
	o.OutsideBusinessHours = v
}

// GetWeekdays returns the Weekdays field value
func (o *HighlightMutable) GetWeekdays() []int32 {
	if o == nil {
		var ret []int32
		return ret
	}

	return o.Weekdays
}

// GetWeekdaysOk returns a tuple with the Weekdays field value
// and a boolean to check if the value has been set.
func (o *HighlightMutable) GetWeekdaysOk() ([]int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Weekdays, true
}

// SetWeekdays sets field value
func (o *HighlightMutable) SetWeekdays(v []int32) {
	o.Weekdays = v
}

// GetStartAt returns the StartAt field value
func (o *HighlightMutable) GetStartAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.StartAt
}

// GetStartAtOk returns a tuple with the StartAt field value
// and a boolean to check if the value has been set.
func (o *HighlightMutable) GetStartAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.StartAt, true
}

// SetStartAt sets field value
func (o *HighlightMutable) SetStartAt(v time.Time) {
	o.StartAt = v
}

// GetEndAt returns the EndAt field value
func (o *HighlightMutable) GetEndAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.EndAt
}

// GetEndAtOk returns a tuple with the EndAt field value
// and a boolean to check if the value has been set.
func (o *HighlightMutable) GetEndAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.EndAt, true
}

// SetEndAt sets field value
func (o *HighlightMutable) SetEndAt(v time.Time) {
	o.EndAt = v
}

func (o HighlightMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HighlightMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["template"] = o.Template
	toSerialize["metric"] = o.Metric
	toSerialize["frequency"] = o.Frequency
	toSerialize["outside_business_hours"] = o.OutsideBusinessHours
	toSerialize["weekdays"] = o.Weekdays
	toSerialize["start_at"] = o.StartAt
	toSerialize["end_at"] = o.EndAt
	return toSerialize, nil
}

type NullableHighlightMutable struct {
	value *HighlightMutable
	isSet bool
}

func (v NullableHighlightMutable) Get() *HighlightMutable {
	return v.value
}

func (v *NullableHighlightMutable) Set(val *HighlightMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableHighlightMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableHighlightMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHighlightMutable(val *HighlightMutable) *NullableHighlightMutable {
	return &NullableHighlightMutable{value: val, isSet: true}
}

func (v NullableHighlightMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHighlightMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


